<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/19/2003 *
 * ===================                          Last change: 08/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-points.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : All your collected points...                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Ihrer gesammelten Punkte                    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Outputs all payout methods the user has
function outputPayoutList ($points) {
	// Enougth points?
	if ($points > 0) {
		// Pay this out!
		$result = SQL_QUERY_ESC("SELECT
	`id`,`type`,`rate`,`min_points`
FROM
	`{?_MYSQL_PREFIX?}_payout_types`
WHERE
	%s >= `min_points`
ORDER BY
	`type` ASC",
			array($points), __FUNCTION__, __LINE__);
		if (!SQL_HASZERONUMS($result)) {
			// Init output
			$OUT = '';

			// Now let's check
			while ($content = SQL_FETCHARRAY($result)) {
				// Are these points enougth?
				if ($points >= $content['min_points']) {
					// Prepare content for template
					$content['points'] = translateComma($points * $content['rate'] - 0.5);

					// Load row template
					$OUT .= loadTemplate('member_payout_li', true, $content);
				} // END - if
			} // END - while

			// Load main template
			loadTemplate('member_payout_list', true, $OUT);
		} else {
			// No payout types setup so far
			loadTemplate('admin_settings_unsaved', false, '{--MEMBER_PAYOUT_SETUP_INCOMPLETE--}');
		}

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// Points is empty
		loadTemplate('admin_settings_unsaved', false, '{--MEMBER_PAYOUT_NO_POINTS_ENTERED--}');
	}
}

// "Translates" the payout status into a human-readable message
function translatePayoutStatus ($status) {
	// Try to get a message from given status
	$message = '{--PAYOUT_STATUS_' . strtoupper($status) . '--}';

	// Return it
	return $message;
}

// "Getter" for payoutable user points
function getPayoutPoints ($userid) {
	// Do we have cache?
	if (!isset($GLOBALS[__FUNCTION__][$userid])) {
		// Determine it
		$GLOBALS[__FUNCTION__][$userid] = countSumTotalData($userid, 'user_points', 'points') - countSumTotalData($userid, 'user_data', 'used_points');
	} // END - if

	// Return it
	return $GLOBALS[__FUNCTION__][$userid];
}

// [EOF]
?>
